SystemOrganization addCategory: #'A4BP-XSD-core'!
SystemOrganization addCategory: 'A4BP-XSD-core-model'!

BPObject subclass: #BPXSDObject
	instanceVariableNames: 'mySchema'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-XSD-core-model'!

BPXSDObject subclass: #BPXSDNamedElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-XSD-core-model'!

BPXSDNamedElement subclass: #BPXSDAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-XSD-core-model'!

!BPXSDAttribute methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 7/3/2014 10:14'!
accept: aVisitor
	^ aVisitor visitBPXSDAttribute: self! !

BPXSDNamedElement subclass: #BPXSDComplexType
	instanceVariableNames: 'lstAtributes xsdSequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-XSD-core-model'!

!BPXSDComplexType class methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 7/3/2014 10:16'!
fillElementsIn: aBPObj from: document
	| visitor |
	"for each element find tags xml"
	visitor := BPBuilderSetNodesinBPXSDComplexTypeVisitor new.
	visitor element: aBPObj.
	self fillElementsIn: aBPObj from: document visitor: visitor.! !

!BPXSDComplexType methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 6/7/2014 09:32'!
accept: aVisitor
	^ aVisitor visitBPXSDComplexType: self! !

!BPXSDComplexType methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 10:28'!
addSimpleType: aXSDSimpleType
	lstElements at: aXSDSimpleType aName put: aXSDSimpleType! !

!BPXSDComplexType methodsFor: 'all' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 00:04'!
allElements
	| lst |
	lst := OrderedCollection new.
	lst addAll: xsdSequence allElements.
	^ lst! !

!BPXSDComplexType methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 00:07'!
fillElementsIn: lst
	lst addAll: self xsdSequence allElements! !

!BPXSDComplexType methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 23:47'!
xsdSequence
	^ xsdSequence! !

!BPXSDComplexType methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 23:47'!
xsdSequence: aSequence
	xsdSequence := aSequence! !

BPXSDNamedElement subclass: #BPXSDElement
	instanceVariableNames: 'type stType lstElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-XSD-core-model'!

!BPXSDElement class methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 6/30/2014 19:13'!
fillElementsIn: aBPObj from: document
	| visitor |
	aBPObj stType: (self readArt: document at: BPParserTagsXMLRef atrType).
	"for each element find tags xml"
	visitor := BPBuilderSetNodesinBPXSDElementVisitor new.
	visitor element: aBPObj.
	self fillElementsIn: aBPObj from: document visitor: visitor.! !

!BPXSDElement methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 11:56'!
accept: aVisitor
	aVisitor visitBPXSDElement: self.! !

!BPXSDElement methodsFor: 'addding' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 08:49'!
addElement: aElement
	lstElements add: aElement.
	type := aElement! !

!BPXSDElement methodsFor: 'all' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 09:50'!
allElements
	| lst |
	lst := OrderedCollection new.
	lst addAll: lstElements.
	lstElements do: [ :el | el fillElementsIn: lst ].
	lst addAll: type allElements.
	^ lst! !

!BPXSDElement methodsFor: 'build-relations' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 09:48'!
buildMeRelations
	| nameElement bpGType |
	"if the code dont find the type is probably that the definitions is primitive element like xsd:String"
	type = BPEmptyObj instance
		ifTrue: [ 
			(stType ~= nil or: (stType ~= ''))
				ifTrue: [ 
					bpGType := BPGenericType newGenericType: self.
					nameElement := mySchema findElementByType: bpGType.
					nameElement ifNotNil: [ type := nameElement ] ] ].
	! !

!BPXSDElement methodsFor: 'all' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 00:06'!
fillElementsIn: lst
	lst addAll: self allElements.
	^ lst! !

!BPXSDElement methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 09:46'!
initialize
	super initialize.
	lstElements := OrderedCollection new.
	type := BPEmptyObj instance! !

!BPXSDElement methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 6/30/2014 19:14'!
stType
	^ stType! !

!BPXSDElement methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 6/30/2014 19:14'!
stType: aString
	stType := aString! !

!BPXSDElement methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 19:35'!
type
	^ type! !

!BPXSDElement methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 19:35'!
type: aType
	type:=aType! !

BPXSDNamedElement subclass: #BPXSDImport
	instanceVariableNames: 'namespace schemaLocation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-XSD-core-model'!

!BPXSDImport class methodsFor: 'builder' stamp: 'AlvaroJosePerltaOcampo 6/2/2014 13:22'!
fillElementsIn: aBPObj from: document
	aBPObj namespace: (document attributeAt: BPParserTagsXMLRef atrNamespace).
	aBPObj schemaLocation: (document attributeAt: BPParserTagsXMLRef atrSchemaLocation).
	^ aBPObj! !

!BPXSDImport methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 7/3/2014 10:14'!
accept: aVisitor
	^ aVisitor visitBPXSDImport: self! !

!BPXSDImport methodsFor: 'getset' stamp: 'AlvaroJosePerltaOcampo 6/2/2014 13:19'!
namespace
	^ namespace! !

!BPXSDImport methodsFor: 'getset' stamp: 'AlvaroJosePerltaOcampo 6/2/2014 13:20'!
namespace: aString
	^ namespace := aString! !

!BPXSDImport methodsFor: 'getset' stamp: 'AlvaroJosePerltaOcampo 6/2/2014 13:20'!
schemaLocation
	^ schemaLocation! !

!BPXSDImport methodsFor: 'getset' stamp: 'AlvaroJosePerltaOcampo 6/2/2014 13:20'!
schemaLocation: aString
	^ schemaLocation := aString! !

BPXSDNamedElement subclass: #BPXSDInclude
	instanceVariableNames: 'namespace schemaLocation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-XSD-core-model'!

!BPXSDInclude class methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 18:13'!
fillElementsIn: aBPObj from: document
	aBPObj namespace: (document attributeAt: BPParserTagsXMLRef atrNamespace).
	aBPObj schemaLocation: (document attributeAt: BPParserTagsXMLRef atrSchemaLocation).
	^ aBPObj! !

!BPXSDInclude methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 7/3/2014 10:14'!
accept: aVisitor
	^ aVisitor visitBPXSDInclude: self! !

!BPXSDInclude methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 18:13'!
namespace
	^ namespace! !

!BPXSDInclude methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 18:13'!
namespace: aString
	^ namespace := aString! !

!BPXSDInclude methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 18:13'!
schemaLocation
	^ schemaLocation! !

!BPXSDInclude methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 18:13'!
schemaLocation: aString
	^ schemaLocation := aString! !

!BPXSDNamedElement methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 7/3/2014 10:14'!
accept: aVisitor
	^ aVisitor visitBPXSDNamedElement: self! !

BPXSDNamedElement subclass: #BPXSDSchema
	instanceVariableNames: 'lstComplexTypes lstSimpleTypes fileName fullPath lstElements targetNamespace nsNameSpaces import include schemaLocation iInternalReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-XSD-core-model'!

!BPXSDSchema class methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 10/30/2014 17:58'!
fillElementsIn: aBPXSDSchema from: document
	| visitor |
	aBPXSDSchema targetNamespace: (self readArt: document at: BPParserTagsXMLRef atrTargetNamespace).
	visitor := BPBuilderSetNodesinBPXSDSchemaVisitor new.
	visitor element: aBPXSDSchema.
	self fillElementsIn: aBPXSDSchema from: document visitor: visitor.
	aBPXSDSchema nsNameSpaces: document nameSpaces.
	aBPXSDSchema buildMeRelations.
	^ aBPXSDSchema! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/2/2014 10:09'!
aName
	aName = ''
		ifTrue: [ ^ self fileName ];
		ifFalse: [ ^ aName ]! !

!BPXSDSchema methodsFor: 'visitor' stamp: 'AlvaroJosePerltaOcampo 6/2/2014 13:17'!
accept: aVisitor
	^ aVisitor visitBPXSDSchema: self! !

!BPXSDSchema methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 6/7/2014 09:35'!
addComplexType: aXSDComplexType
	lstComplexTypes at: aXSDComplexType aName put: aXSDComplexType! !

!BPXSDSchema methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 11:40'!
addElement: aElement
	lstElements at: aElement aName put:aElement ! !

!BPXSDSchema methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 18:35'!
addImport: aWSDLImport
	import := aWSDLImport! !

!BPXSDSchema methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 6/7/2014 09:34'!
addSimpleType: aXSDSimpleType
	lstSimpleTypes at: aXSDSimpleType aName put: aXSDSimpleType! !

!BPXSDSchema methodsFor: 'build-relations' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 09:09'!
buildMeRelations
	"Message to start to build my relations into my elements and my types"

	lstElements do: [ :el | el buildMeRelations ].! !

!BPXSDSchema methodsFor: 'build-relations' stamp: 'AlvaroJosePeraltaOcampo 6/20/2014 23:26'!
buildRelations: aRelation
	aRelation buildRelationsBpXSDSchema: self! !

!BPXSDSchema methodsFor: 'build-relations' stamp: 'AlvaroJosePeraltaOcampo 6/21/2014 02:44'!
buildRelationsBpProcess: aBPProcess
	aBPProcess buildRelationsBpXSDSchema: self! !

!BPXSDSchema methodsFor: 'build-relations' stamp: 'AlvaroJosePeraltaOcampo 6/21/2014 11:59'!
buildRelationsBpWsdls: aBPWSDL
	aBPWSDL buildRelationsBpXSDSchema: self.! !

!BPXSDSchema methodsFor: 'build-relations' stamp: 'AlvaroJosePeraltaOcampo 7/3/2014 09:28'!
buildRelationsBpXSDSchema: aBPXSDSchema
	| matchPattern |
	self isInternalReference 
		ifTrue: [ 
			matchPattern := '*' , aBPXSDSchema fileName , '*'.
			(matchPattern match: self schemaLocation)
				ifTrue: [ parent addRelation: aBPXSDSchema ] ]! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 11:39'!
elements
	^ lstElements! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 11:38'!
elements: aLstElements
	lstElements := aLstElements ! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePerltaOcampo 6/3/2014 20:35'!
fileName
	^ fileName! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePerltaOcampo 6/3/2014 20:33'!
fileName: aFileName
	fileName := aFileName! !

!BPXSDSchema methodsFor: 'finder' stamp: 'AlvaroJosePeraltaOcampo 6/21/2014 02:18'!
findDefType: aDefType
	^ self findNameElement: aDefType element! !

!BPXSDSchema methodsFor: 'finder' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 09:26'!
findElementByType: bpGType
	^ self findNameElement: bpGType element.! !

!BPXSDSchema methodsFor: 'finder' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 09:26'!
findNameElement: aKeyName
	| el |
	el := BPEmptyObj instance.
	[ ^ el := self lstElements at: aKeyName ]
		on: KeyNotFound
		do: [  ].
	[ ^ el := self lstComplexTypes at: aKeyName ]
		on: KeyNotFound
		do: [  ].
	[ ^ el := self lstSimpleTypes at: aKeyName ]
		on: KeyNotFound
		do: [  ].
	^ el! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePerltaOcampo 6/3/2014 20:35'!
fullPath
	^ fullPath! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePerltaOcampo 6/3/2014 20:35'!
fullPath: aFullPath
	fullPath := aFullPath! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/3/2014 09:18'!
iInternalReference: aBool
	^ iInternalReference := aBool! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/3/2014 09:38'!
import
	^ import! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/3/2014 09:38'!
import: aImport
	import := aImport! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/9/2014 23:30'!
include
	^ include! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/9/2014 23:30'!
include: aInclude
	^ include :=aInclude ! !

!BPXSDSchema methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 7/3/2014 09:24'!
initialize
	super initialize.
	lstComplexTypes := Dictionary new.
	lstSimpleTypes := Dictionary new.
	lstElements := Dictionary new.
	iInternalReference:=false.
	import := BPEmptyObj instance.
	include := BPEmptyObj instance.
	mySchema := self.! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/3/2014 09:18'!
isInternalReference
	^ iInternalReference ! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 6/9/2014 13:20'!
label
	^ aName , '>' , self fileName! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 09:12'!
lstComplexTypes
	^ lstComplexTypes! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 12:05'!
lstElements
	^ lstElements! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 09:12'!
lstSimpleTypes
	^ lstSimpleTypes! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 18:38'!
namespace
	^ targetNamespace! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 18:22'!
nsNameSpaces
	^ nsNameSpaces! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 18:21'!
nsNameSpaces: aDictionary
	nsNameSpaces := aDictionary! !

!BPXSDSchema methodsFor: 'metrics' stamp: 'AlvaroJosePeraltaOcampo 6/7/2014 09:14'!
numberOfComplexTypes
	^ lstComplexTypes size! !

!BPXSDSchema methodsFor: 'metrics' stamp: 'AlvaroJosePeraltaOcampo 6/7/2014 09:14'!
numberOfSimpleTypes
	^ lstSimpleTypes size! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/9/2014 23:32'!
schemaLocation
	import isBPEmtyObj ifFalse: [ ^ import schemaLocation ].
	include isBPEmtyObj ifFalse: [ ^ include schemaLocation ].
	^ ''
	! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 21:14'!
targetNamespace
	^ targetNamespace! !

!BPXSDSchema methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 21:14'!
targetNamespace: aString
	targetNamespace := aString ! !

BPXSDNamedElement subclass: #BPXSDSequence
	instanceVariableNames: 'lstElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-XSD-core-model'!

!BPXSDSequence class methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 23:49'!
fillElementsIn: aBPObj from: document
	| visitor |
	"for each element find tags xml"
	visitor := BPBuilderSetNodesinBPXSDSequenceVisitor new.
	visitor element: aBPObj.
	self fillElementsIn: aBPObj from: document visitor: visitor.! !

!BPXSDSequence methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 7/3/2014 10:15'!
accept: aVisitor
	^ aVisitor visitBPXSDSequence: self! !

!BPXSDSequence methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 00:00'!
addElement: aElement
	lstElements add: aElement! !

!BPXSDSequence methodsFor: 'all' stamp: 'AlvaroJosePeraltaOcampo 6/30/2014 16:26'!
allElements
	| lst |
	lst := OrderedCollection new.
	lst addAll: lstElements.
	lstElements do: [ :el | el fillElementsIn: lst ].
	^ lst! !

!BPXSDSequence methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 20:56'!
elements
	^ lstElements! !

!BPXSDSequence methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 7/2/2014 00:02'!
initialize
	super initialize.
	lstElements := OrderedCollection new.! !

!BPXSDSequence methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 20:56'!
lstElements
	^ lstElements! !

!BPXSDSequence methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 6/15/2014 20:55'!
lstElements: aLstElements
	lstElements:=aLstElements ! !

BPXSDNamedElement subclass: #BPXSDSimpleType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-XSD-core-model'!

!BPXSDSimpleType methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 6/7/2014 09:32'!
accept: aVisitor
	^ aVisitor visitBPXSDSimpleType: self! !

!BPXSDSimpleType methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 6/30/2014 16:24'!
allElements
	^ OrderedCollection new add: self! !

!BPXSDSimpleType methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 6/30/2014 16:23'!
fillElementsIn: lst
	lst ifNotNil: [ lst add: self ]! !

!BPXSDObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 6/10/2014 09:53'!
fillElementsIn: aBPObject from: document visitor: visitor
	self fillElementsIn: aBPObject from: document visitor: visitor tagRef:BPParserXSDTagsXMLRef! !

!BPXSDObject methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 6/10/2014 09:20'!
accept: aVisitor
	^ aVisitor visitBPXSDObject: self! !

!BPXSDObject methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 09:05'!
mySchema
	^ mySchema! !

!BPXSDObject methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 7/1/2014 09:05'!
mySchema: aSchema
	mySchema :=aSchema ! !
